#include <bits/stdc++.h>

using namespace std;

const long long INF = 2e18;

long long get_dif_horizontal(long long &n, long long &m, long long &k) {
    long long sum = ((n * m) % 2 == 0) ? ((n * m) / 2 * (n * m + 1)) : ((n * m + 1) / 2 * (n * m));
    long long up = (k * m) % 2 == 0 ? (k * m) / 2 * (k * m + 1) : (k * m + 1) / 2 * (k * m);
    long long down = (sum - up);
    return abs(up - down);
}

long long get_dif_vertical(long long &n, long long &m, long long &k) {
    long long sum = ((n * m) % 2 == 0) ? ((n * m) / 2 * (n * m + 1)) : ((n * m + 1) / 2 * (n * m));
    long long lefta = ((k) % 2 == 0) ? k / 2 * (k + 1) * n : (k + 1) / 2 * k * n;
    long long leftb = (n % 2 == 0) ? n / 2 * (n - 1) * m * k : (n - 1) / 2 * n * m * k;
    long long left = lefta + leftb;
    long long right = sum - left;
    return abs(right - left);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;

    cin >> T;

    while (T--) {
        long long n, m;

        cin >> n >> m;

        long long l = 0, r = n + 1;
        long long ansH = -1, ansHval = INF;
        long long ansV = -1, ansVval = INF;

        while (l != r - 2) {
            long long mid1 = l + (r - l) / 3;
            long long mid2 = r - (r - l) / 3;

            long long val1 = get_dif_horizontal(n, m, mid1);
            long long val2 = get_dif_horizontal(n, m, mid2);
            if (val1 >= val2) {
                l = mid1;
            } else {
                r = mid2;
            }
        }
        for (long long i = l; i < l + 3; i++) {
            if (-1 < i && i < n) {
                if (get_dif_horizontal(n, m, i) < ansHval) {
                    ansHval = get_dif_horizontal(n, m, i);
                    ansH = i;
                }
            }
        }

        l = 0, r = m + 1;
        while (l != r - 2) {
            long long mid1 = l + (r - l) / 3;
            long long mid2 = r - (r - l) / 3;

            long long val1 = get_dif_vertical(n, m, mid1);
            long long val2 = get_dif_vertical(n, m, mid2);
            if (val1 >= val2) {
                l = mid1;
            } else {
                r = mid2;
            }
        }

        for (long long i = l; i < l + 3; i++) {
            if (-1 < i && i < m) {
                if (get_dif_vertical(n, m, i) < ansVval) {
                    ansVval = get_dif_vertical(n, m, i);
                    ansV = i;
                }
            }
        }
        if (ansHval < ansVval) {
            cout << "H " << ansH + 1 << endl;
        } else {
            cout << "V " << ansV + 1 << endl;
        }
    }
}